/**
 * Copyright © CENRA (2016)
 *
 * remi.clement@espaces-naturels.fr
 * 
 * This software is a multi-platform and portable application based on 
 * the scientifical toolbox to monitor wetlands. With this toolbox it’s 
 * possible to calculate indicators «RhoMéO» to monitor quality, 
 * fonctionalities and urban and agricultural pressures of wetlands. 
 * Indicators are calculated using naturalist data entered and/or imported,
 * and geographic data downloaded from a geographic server.
 * 
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use, 
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info". 
 * 
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability. 
 * 
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or 
 * data to be ensured and,  more generally, to use and operate it in the 
 * same conditions as regards security. 
 * 
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
*/
package fr.cenra.rhomeo.protocol.p02;

import fr.cenra.rhomeo.api.data.ObjectWrapper;
import fr.cenra.rhomeo.core.RhomeoCore;
import fr.cenra.rhomeo.core.data.ReferenceManager;
import fr.cenra.rhomeo.core.data.reference.FloreBassinReference;
import fr.cenra.rhomeo.core.data.reference.FloreBassinReferenceDescription;
import java.time.LocalDate;
import java.util.List;
import java.util.Optional;
import java.util.logging.Level;
import org.apache.sis.util.collection.Cache;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 *
 * @author Alexis Manin (Geomatys)
 */
@Component
public class P02Wrapper implements ObjectWrapper<FloreStatement, P02Wrapper.CustomFloreStatement> {

    private final Cache<Integer, String> cache = new Cache<>(100, 0, true);

    @Autowired
    FloreBassinReferenceDescription refDesciption;

    @Override
    public Class<FloreStatement> getInputType() {
        return FloreStatement.class;
    }

    @Override
    public Class<P02Wrapper.CustomFloreStatement> getOutputType() {
        return P02Wrapper.CustomFloreStatement.class;
    }

    @Override
    public CustomFloreStatement apply(FloreStatement t) {
        return new CustomFloreStatement(t);
    }

    private String getName(final int cdNom) {
        try {
            return cache.getOrCreate(cdNom, () -> {
                Optional<List<FloreBassinReference>> lastLoaded = ReferenceManager.getOrCreate(refDesciption).getLastLoaded();
                if (lastLoaded.isPresent()) {
                    final List<FloreBassinReference> refs = lastLoaded.get();
                    for (final FloreBassinReference ref : refs) {
                        if (ref.getCd_nom() == cdNom)
                            return ref.getNom();
                    }
                }
                return null;
            });
        } catch (Exception ex) {
            RhomeoCore.LOGGER.log(Level.FINE, "Cannot compute name", ex);
            return null;
        }
    }

    public class CustomFloreStatement {

        final FloreStatement wrapped;

        private CustomFloreStatement(final FloreStatement input) {
            wrapped = input;
        }

        public LocalDate getDate() {
            return wrapped.getDate();
        }

        public String getTrackingPoint() {
            return wrapped.getTrackingPoint();
        }

        public String getRemarks() {
            return wrapped.getRemarks();
        }

        public String getPhysionomy() {
            return wrapped.getPhysionomy();
        }

        public int getCd_nom() {
            return wrapped.getCd_nom();
        }

        public String getAbundance() {
            return wrapped.getAbundance();
        }

        public String getNom_complet() {
            if (wrapped.getCd_nom() > 0) {
                return getName(wrapped.getCd_nom());
            }

            return null;
        }
    }
}
